<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    If you find this script useful, please make a donation via the main       //
//    website:                                                                  //
//                          http://www.minigal.dk                               //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

// DISPLAY ERRORS BUT HIDE NOTICES
error_reporting(E_ALL ^ E_NOTICE);

// SET PHP ARGUMENT SEPERATOR ON '&AMP'
@ini_set('arg_separator.output','&amp;');

// SESSION START 
session_start();

// TRIGGER INSTALLATION
if(!is_file('mg2_settings.php')) @include('mg2_install.php');

// MAKE NEW DATABASE OBJECT
include('includes/mg2_functions.php');
include('includes/mg2admin_functions.php');
$mg2 = new MG2admin;
$mg2->readDB();

// BASIC SETTINGS
$mg2->adminfolder	= 'skins/admin/';
$mg2->extendedset = '29';

// READ FILE SETTINGS
include('includes/mg2_version.php');
include('mg2_settings.php');

//
// READ LANGUAGES
// kh_mod 0.1.0, changed
if ($_REQUEST['action'] == 'writesetup') {
	$selectedlang = $mg2->charfix($_REQUEST["defaultlang"], '/');
	if (!empty($selectedlang)) $mg2->defaultlang = $selectedlang;
}
if (!is_readable('lang/'.$mg2->defaultlang))	$mg2->defaultlang = 'english.php';
if (is_readable('lang/'.$mg2->defaultlang)) include('lang/'.$mg2->defaultlang);

// SET HEADERS TO PREVENT BROWSER CACHING OF PAGES
@header('Content-Type: text/html; charset='.$mg2->charset);
@header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
@header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
@header('Cache-Control: no-store, no-cache, must-revalidate');
@header('Cache-Control: post-check=0, pre-check=0', false);
@header('Pragma: no-cache');

// HTML-HEADER
include($mg2->adminfolder .'admin_header.php');

// LOGIN SECURITY CHECK
$firstlogin = $mg2->security();

////////////////////////////
// MENU
////////////////////////////
if (!$_REQUEST['list']) $list = "1"; else $list = $_REQUEST['list'];
if ($_REQUEST['editfolder']) $list = $_REQUEST['editfolder'];


for ($i=0; $i < count($mg2->all_images);$i++) {
	$total_size = $total_size + $mg2->all_images[$i][5];
}
$dec = "1"; $val = " bytes";
if (strlen($total_size) > 3) { $dec="1024"; $val=" Kb"; }
if (strlen($total_size) > 6) { $dec="1048576"; $val=" Mb"; }
$total_size = round($total_size/$dec,2) . $val;
$total_images = count($mg2->all_images);
if ($total_images == 1)	$total_images = $total_images ." ". $mg2->lang['file']; else $total_images = $total_images . " " . $mg2->lang['files'];
$total_folders = count($mg2->all_folders) - 1;
if ($total_folders < 0) $total_folders = 0;
if ($total_folders == 1) $total_folders = $total_folders ." ". $mg2->lang['folder']; else $total_folders = $total_folders . " " . $mg2->lang['folders'];
include($mg2->adminfolder .'admin1_menu.php');

// LANGUAGE INSTALLED?
if (empty($mg2->lang)) {
	$mg2->status = '<span style="color:red">There is no language intsalled!</span>';
	$mg2->displaystatus();
}

// USED SKIN NOTAVAILABLE OR UP TO DATE?
if ($firstlogin) {
	$skinpath = 'skins/'. $mg2->activeskin .'/';
	if (!is_readable($skinpath .'templates')) {
		$_REQUEST['action'] = 'setup';
		$mg2->status = '<span style="color:red">The skin "'. ucfirst($mg2->activeskin);
		$mg2->status.= '" is not available! Please select another one.</span>';
		$mg2->displaystatus();
	}
	elseif (is_readable($skinpath .'settings.php')) {
		include ($skinpath .'settings.php');
		if (!strpos($skin_version,'kh_mod')) {
			$display = ($skin_version)? '('. $skin_version .') ':'';
			$mg2->status = '<span style="color:red">Your skin version '. $display .'of "';
			$mg2->status.= ucfirst($mg2->activeskin) .'" is not up to date!</span>';
			$mg2->displaystatus();
		}
	}
}

// UPLOAD ERROR?
if ($_REQUEST['loading'] && $_REQUEST['action'] != 'upload') {
	$max_upload  = get_cfg_var('upload_max_filesize');
	$mg2->status = 'ERROR: Upload missed! Selected file(s) are &gt; ';
	$mg2->status.= @preg_replace('/(\d+)M$/','${1} MByte',$max_upload);
	$mg2->displaystatus();
}

// kh_mod 0.1.0, changed
if (!empty($_REQUEST['action']))
switch ($_REQUEST['action']) {
	case "updateID":
		if ($mg2->updateID($_REQUEST['id'])) {
			$mg2->getfoldersettings($_REQUEST['list'], true);
			$images = $mg2->select($_REQUEST['list'],$mg2->all_images,2,$mg2->folder_sortby,$mg2->folder_sortway);
			for ($i=0; $i < count($images); $i++) {
				if ($images[$i][0] == $_REQUEST['id']) break;
			}
			$_REQUEST['editID'] = $images[$i+1][0];
		} else
			$_REQUEST['editID'] = $_REQUEST['id'];
		break;
	case "dbbackup":
		$mg2->db_backup();
		break;
	case "startimport":
		$mg2->makefolderlist();
		include($mg2->adminfolder ."admin2_import.php");
		break;
	case "import":
		if (!$mg2->importstart($_REQUEST['list']))
			unset($_REQUEST['action']);
		break;
	case "makefolder":
		$mg2->makefolder();
		$_REQUEST['list'] = $_REQUEST['moveto'];
		break;
	case "deleteID":
		$mg2->deleteID();
		break;
	case "upload":
		if ($mg2->upload($_REQUEST['list'])) {
			include($mg2->adminfolder ."admin4_credits.php");
			include($mg2->adminfolder ."admin_footer.php");
			exit();
		}
		break;
	case "updatefolder":
		$mg2->updatefolder();
		$_REQUEST['editfolder'] = $_REQUEST['list'];
		break;
	case "writesetup":
		$mg2->writesetup();
		break;
	case "deletecomments":
		$imageID = (int)$_REQUEST['editID'];
		$commNum = (int)$_REQUEST['num'];
		$mg2->deletecomments($imageID, $commNum);
		break;
	case "setup": //MG2 SETUP
		$mg2->setup();
		include($mg2->adminfolder ."admin4_credits.php");
		include($mg2->adminfolder ."admin_footer.php");
		exit();
}
// end

if ($_REQUEST['erasefolder']) {
	$_REQUEST['list'] = $mg2->erasefolder($_REQUEST['erasefolder']);
}

// kh_mod 0.1.0, add
if (substr($_REQUEST['updatecomment'],0,7)==='comment') {
	$updatedComment = $mg2->updatecomment($_REQUEST['editID']);
	if ($updatedComment===false) {
		// BACK TO 'EDIT COMMENT' DIALOG
		$_REQUEST['editcomment'] = $_REQUEST['updatecomment'];
	}
}
// end

//
// DISPLAY DIALOGS
//

// kh_mod 0.1.0, add
if (substr($_REQUEST['editcomment'],0,7)==='comment') {
	if ($mg2->editcomment($_REQUEST['editID'])) {
		include($mg2->adminfolder .'admin4_credits.php');
		include($mg2->adminfolder .'admin_footer.php');
		exit();
	}
}
// end

// kh_mod 0.1.0, add
if (substr($_REQUEST['deletecomment'],0,7)==='comment') {
	if ($mg2->askdelcomment($_REQUEST['editID'])) {
		include($mg2->adminfolder .'admin4_credits.php');
		include($mg2->adminfolder .'admin_footer.php');
		exit();
	}
}
// end

// DELETE FILES, kh_mod 0.1.0 b3, changed
if ($_REQUEST['deletefiles']) {
	$del_request = html_entity_decode($_REQUEST['deletefiles']);
	$del_value	 = html_entity_decode($mg2->lang['buttondelete']);
	if ($del_request == $del_value) $mg2->deletefiles();
}

// MOVE FILES, kh_mod 0.1.0 b3, changed
if ($_REQUEST['movefiles']) {
	$move_request = html_entity_decode($_REQUEST['movefiles']);
	$move_value	  = html_entity_decode($mg2->lang['buttonmove']);
	if ($move_request == $move_value) $mg2->movefiles();
}

// UPLOAD DIALOG
if($_REQUEST['startupload']) {
	$mg2->makefolderlist();
	$_REQUEST['list'] = $_REQUEST['startupload'];
	include($mg2->adminfolder .'admin2_upload.php');
}

// kh_mod 0.1.0, add
if($_REQUEST['newfolder']) {
	$_REQUEST['list'] = $_REQUEST['newfolder'];
	include($mg2->adminfolder .'admin2_newfolder.php');
}
// end
if ($_REQUEST['editfolder']) {
	$_REQUEST['list'] = $mg2->editfolder($Calendar);
}

// kh_mod 0.1.0, add
if($_REQUEST['rebuildfolder']) {
	$mg2->rebuildfolder();
	$_REQUEST['list'] = $_REQUEST['rebuildfolder'];
}
// end

// kh_mod 0.1.0, changed
if ($_REQUEST['deleteID']) {
	$_REQUEST['list'] = $mg2->askdeleteID();
}
// end

if ($_REQUEST['deletefolder']) {
	$mg2->askdelfolder();
}

// kh_mod 0.1.0, changed
if ($_REQUEST['rebuildID']) {
	$image = $mg2->select($_REQUEST['rebuildID'],$mg2->all_images,0,0,0);
	if ($image) $_REQUEST['list'] = $image[0][2];

	// REBUILD THUMB AND MEDIUM IMAGE
	$update = $mg2->rebuildID($image[0][0],$image[0][1]);

	// UPDATE IMAGE DATABASE
	if ($update && !$mg2->write_iDB('update'))
		$mg2->log('ERROR: Couldn\'t update image database!');
}
// end

if ($_REQUEST['rotate']) {
	$mg2->rotateimage($_REQUEST['rotate'], $_REQUEST['direction']);
	$_REQUEST['editID'] = $_REQUEST['rotate'];
}

if ($_REQUEST['editID']) {
	$mg2->editID($updatedComment, $Calendar);
}

if ($_REQUEST['action'] != 'import') {

	if ($_REQUEST['list'] == '') $_REQUEST['list'] = '1';
	if (!$mg2->getfoldersettings($_REQUEST['list'], true)) {
		$mg2->displaystatus($mg2->lang['nofolderid'] .' #'. $_REQUEST['list']);
		if ($_REQUEST['list'] != '1') {
			$_REQUEST['list'] = '1';
			$mg2->getfoldersettings($_REQUEST['list'], true);
		}
	}

	// kh_mod 0.1.0, add
	if ((int)$mg2->foldersort>0)
		$tmp_sort = (int)$mg2->foldersort;		// global setting
	else
		$tmp_sort = (int)$mg2->folder_sortby;	// folder setting

	switch ($tmp_sort) {
		case  1 : $trans_sortby =  2; break;	// filename	->	foldername
		case  3 : $trans_sortby =  2; break;	// title		->	foldername
		case  4 : $trans_sortby = 10; break;	// description	->	description
		case  5 : $trans_sortby =  2; break;	// filesize	->	foldername
		case  6 : $trans_sortby =  2; break;	// width		->	foldername
		case  7 : $trans_sortby =  2; break;	// height		->	foldername
		case 10 : $trans_sortby =  6; break;	// timestamp	->	timestamp
		case 11 : $trans_sortby = 11; break;	// position	->	position
		default : $trans_sortby =  2;
	}
	// end

	$folders  = $mg2->select($_REQUEST['list'],$mg2->all_folders,1,$trans_sortby,$mg2->folder_sortway);		// kh_mod 0.1.0, changed
	$images   = $mg2->select($_REQUEST['list'],$mg2->all_images,2,$mg2->folder_sortby,$mg2->folder_sortway);	// kh_mod 0.1.0, changed
	$cfolders = count($folders);																										// kh_mod 0.1.0, add
	$cimages  = count($images);																										// kh_mod 0.1.0, add

	//
	// PAGE COUNTER
	// kh_mod 0.1.0, changed

	//CALCULATE NUMBER OF PAGES NEEDED
	$prpage = $mg2->imagecolumns * $mg2->imagerows;
	$pages  = ceil($cimages / $prpage);

	//CALCULATE FIRST AND LAST INDEX OF PAGE 
	if ($_REQUEST['page'] == "") $_REQUEST['page'] = 1;
	if ($_REQUEST['page'] == "all") {
		$first = 0;
		$last  = $cfolders + $cimages;
	}
	else {
		$first = $prpage * ($_REQUEST['page'] - 1);
		$last  = $first  + $prpage;
	}

	//
	// LIST FOLDERS
	// kh_mod 0.1.0, changed
	if ($mg2->folder_position < 0) {
		$tableHead = ' bgcolor="#FFCFCF" title="'. $mg2->lang['nodisplay'];
		$tableHead.= ' ('. $mg2->lang['position'] .' '. $mg2->folder_position .')"';
	}
	elseif ($mg2->folder_publish > time()) {
		$tableHead = ' bgcolor="#FFFF99" title="'. $mg2->lang['notpublished'];
		$tableHead.= ' '. $mg2->time2date($mg2->folder_publish) .'"';
	}
	else {
		$tableHead = '';
	}
	$class = 'table_files';
	include($mg2->adminfolder .'admin_table_start.php');
	for ($i=0; $i < $cfolders; $i++) {
		// IS SET FOLDER PASSWORT?
		if ($folders[$i][5] != '') {
			$small_icon = $mg2->adminfolder .'images/folder_small_locked.gif';
		}
		// IS SET FOLDER THUMBNAIL?
		elseif ($folders[$i][7] != '') {
			$small_icon = $mg2->adminfolder .'images/folder_small_thumb.gif';
		}
		// STANDARD ICON
		else {
			$small_icon = $mg2->adminfolder .'images/folder_small.gif';
		}

		// GET PUBLISH DATE OF FOLDER
		$publishdate = $mg2->time2date($folders[$i][6]);
		include($mg2->adminfolder .'admin3_folders.php');
	}

	//
	// LIST FILES
	// kh_mod 0.1.0, changed
	$upto = ($cimages < $last)? $cimages:$last;
	for ($i=$first; $i < $upto; $i++) {
		// COUNTER START BY 0
		$num = $i-$first;

		// GET THUMB FILE
		$thumbfile = $mg2->thumb($images[$i][1]);
		if (!$thumb_ok = is_readable($thumbfile))
			$thumbfile = $mg2->adminfolder .'images/1x1.gif';

		// CALCULATE FILE SIZE
		$dec = 1;
		$val = ' bytes';
		if (strlen($images[$i][5]) > 3) { $dec=1024;    $val=' KB'; }
		if (strlen($images[$i][5]) > 6) { $dec=1048576; $val=' MB'; }
		$filesize = @number_format(round(($images[$i][5]/$dec),2), 2, '.', ','). $val;

		// GET THUMB SIZE
		$thumb_width  = $images[$i][8];
		$thumb_height = $images[$i][9];

		// CALCULATE MINITHUMB SIZE
		$minithumb_width  = (string)(round(($images[$i][8]/5),0));
		$minithumb_heigth = (string)(round(($images[$i][9]/5),0));

		// GET PUBLISH DATE OF FILE
		$publishdate = $mg2->time2date($images[$i][10]);

		// GET THUMB INFO
		$thumb_info ='';
		if (($mg2->extendedset & 8) && $thumb_ok)
		if ($thumb_ok && include_once('includes/exif.php')) {
			exif($mg2->image($images[$i][1]));
			$d = preg_split('/(:|\s)/', $exif_data['DTOpticalCapture'],6,PREG_SPLIT_NO_EMPTY);
			$exif_data['DTOpticalCapture'] = ''; // RESET FOR NEXT LOOPS RUN, kh_mod 0.1.0 b3, add
			$exif_date  = mktime($d[3], $d[4], $d[5], $d[1], $d[2], $d[0]);
			$thumb_info = 'this.T_WIDTH='.($thumb_width+10).';return escape(\'<img src=\\\''.$thumbfile;
			$thumb_info.= '\\\' width=\\\''.$thumb_width.'\\\' height=\\\''.$thumb_height.'\\\' alt=\\\'\\\' />';
			$thumb_info.= '<br />ID: #'. $images[$i][0] .',&nbsp;Exif-'. $mg2->lang['date'];
			$thumb_info.= ($exif_date > 0)?
							  ':<br />'. $mg2->time2date($exif_date, true) .'\')'
							  :
							  ': -\')';
		}
		include($mg2->adminfolder .'admin3_files.php');
	}
	include($mg2->adminfolder .'admin_table_end.php');

	// DISPLAY CONTROLS
	$selectsize = $upto - $first;
	if (empty($mg2->sortedfolders)) $mg2->makefolderlist();
	include($mg2->adminfolder .'admin4_controls.php');
}
// END NON IMPORT

include($mg2->adminfolder .'admin4_credits.php');
include($mg2->adminfolder .'admin_footer.php');

?>