<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    If you find this script useful, please make a donation via the main       //
//    website:                                                                  //
//                          http://www.minigal.dk                               //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

//
// DISPLAY THUMBNAIL HEADER
// kh_mod 0.1.0, add
function thumbnails_begin($pages=1, $list=1) {
	global $mg2;

	if ($list == 1) $currentfolder = $mg2->gallerytitle;
	else $currentfolder = $mg2->getfoldername($list);
	include('skins/'.$mg2->activeskin.'/templates/thumbnails_begin.php');
}

//
// DISPLAY IMAGE OR FOLDER NOT EXISTS
// kh_mod 0.1.0, add
function notexists($id,$list='',$page='') {
	global $mg2;
	if ($id=='demaged')
		$noexists = $mg2->lang['requestfolder'] . $mg2->lang['damaged'];
	elseif ((int)$id>0)
		$noexists = $mg2->lang['noimage'];
	else
		$noexists = $mg2->lang['requestfolder'] . $mg2->lang['notexists'];
	$page = ($page)? $page:'1';
	$list = ($list)? $list:'1';
	$_REQUEST['list'] = $list;
	$_REQUEST['id']	= '';
	$mg2->introtext	= '';
	$currentfolder		= $mg2->gallerytitle;
	include('skins/'.$mg2->activeskin.'/templates/thumbnails_begin.php');
	echo '
		<td align="center"><nobr><b>'.$noexists.'</b></nobr><br />&nbsp;</td></tr>
		<tr><td align="center">
			<a href="'.$mg2->indexfile.'?list='.$list.'&amp;page='.$page.'">'
			.$mg2->lang['viewgallery'].'</a>
		</td></tr></table></body></html>
	';
	exit();
}


class mg2db {

	//
	// READ ENTIRE DATABASE
	//
	function readDB() {

		// IMAGE DATABASE
		$iDB = 'mg2db_idatabase.php';
		if (is_file($iDB)) {
			$fd = fopen($iDB,'rb');
			if ($fd && is_resource($fd)) {
				$this->autoid = trim(fgets($fd,4096));
				while (!feof($fd)) {
					// kh_mod 0.1.0, changed
					if (fgets($fd,2) !== "*") continue;
					$tmp_arr = fgetcsv($fd,4096,"*");
					$tmp_arr[11] = (isset($tmp_arr[11]))? (int)$tmp_arr[11]:1;
					$this->all_images[] = $tmp_arr;
					// end
				}
				fclose($fd);
			}
		} else {
			$fd = fopen($iDB,'w');
			fclose($fd);
		}

		// FOLDER DATABASE
		$fDB = 'mg2db_fdatabase.php';
		if (is_file($fDB)){
			$fd = fopen($fDB,'rb');
			if ($fd && is_resource($fd)) {
				$this->folderautoid = trim(fgets($fd,4096));
				while (!feof($fd)) {
					// kh_mod 0.1.0, changed
					if (fgets($fd,2) !== "*") continue;
					$tmp_arr = fgetcsv($fd,4096,"*");
					$tmp_arr[11] = (isset($tmp_arr[11]))? (int)$tmp_arr[11]:1;
					$this->all_folders[] = $tmp_arr;
					// end
				}
				fclose($fd);
			}
		} else {
			$fd = fopen($fDB,'w');
			fwrite($fd,"1\n");
			fwrite($fd,'*1*root**1*0**'. time() .'*****1');		// kh_mod 0.1.0, changed
			fclose($fd);
		}
	}

	//
	// SELECT ENTRIES FROM DATABASE
	// kh_mod 0.1.0, changed
	function select($key,$array,$row,$sortrow=0,$sortmode=0,$date=0) {
		$selectarray = array();
		if ($date) {
			$now = time();
			for ($idx=0; $idx < count($array); $idx++) {
				if ($array[$idx][$row] == $key)		// gesuchter Key
				if ($array[$idx][$date] <= $now)		// Datum nicht in der Zukunft
				if ((int)$array[$idx][11] >= 0)		// Position >= 0
					$selectarray[] = $array[$idx];
			}
		}
		else {
			for ($idx=0; $idx < count($array); $idx++) {
				if ($array[$idx][$row] == $key)
					$selectarray[] = $array[$idx];
			}
		}
		if (count($selectarray) > 1) $this->sort($selectarray,$sortrow,$sortmode);
		return $selectarray;
	}

	//
	// SORT SEARCH RESULTS
	// kh_mod 0.1.0, changed
	function sort(&$datatable,$field,$mode) {
		if (!isset($field)) return;
		$comp = ($mode)? '>':'<';
		$code = '$field='.$field.';';
		$code.= 'if ($a[$field]==$b[$field]) $field=0;';
		$code.= 'return ($a[$field]'.$comp.'$b[$field])? -1:1;';
		$compare = create_function('$a,$b', $code);
		usort($datatable, $compare);
	}

	//
	// DISPLAY SLIDIESHOW ICON
	// kh_mod 0.1.0, add
	function slideshowicon($attrib='') {
		if (empty($this->startimage)) {
			echo '<img src="skins/'. $this->activeskin .'/images/slideshow.gif" ';
			echo 'width="15" height="17" '. $attrib .' alt="" border="0" />';
		} else {
			echo '<a href="'. $this->indexfile .'?slideshow='. $this->startimage .'">';
			echo '<img src="skins/'. $this->activeskin .'/images/slideshow.gif" ';
			echo 'width="15" height="17" '. $attrib .' alt="'. $this->lang['viewslideshow'];
			echo '" title="'. $this->lang['viewslideshow'] .'" border="0" /></a>';
		}
	}

	//
	// IMAGE NAVIGATION
	// kh_mod 0.1.0, changed
	function imagenavigation($list, $id, $admin=false) {
		// kh_mod 0.1.0, add
		if ($admin===true) {
			$folders  = $this->select($list,$this->all_folders,1,0,0);
			$images   = $this->select($list,$this->all_images,2,$this->folder_sortby,$this->folder_sortway);
			$cfolders = 0;
			$href = './admin.php?editID=';
		} else {
			$folders  = $this->select($list,$this->all_folders,1,0,0,6);
			$images   = $this->select($list,$this->all_images,2,$this->folder_sortby,$this->folder_sortway,10);
			$cfolders = count($folders);
			$href = './'.$this->indexfile.'?id=';
		}
		// end

		$this->nav_total = count($images);
		for ($i=0; $i < $this->nav_total; $i++) {
			if ($id == $images[$i][0]) {
				$this->page = ceil(($i + 1 + $cfolders) / ($this->imagerows * $this->imagecolumns));
				$this->nav_current = $i + 1;
				break;
			}
		}

		// NAVIGATION LINKS
		$links['first'] = '<a href="'. $href . $images[0][0] .'&amp;page='.$this->page.'">';
		$links['prev']  = '<a href="'. $href . $images[$this->nav_current - 2][0] .'&amp;page='.$this->page.'">';
		$links['next']  = '<a href="'. $href . $images[$this->nav_current][0] .'&amp;page='.$this->page.'">';
		$links['last']  = '<a href="'. $href . $images[$this->nav_total - 1][0] .'&amp;page='.$this->page.'">';

		// NAVIGATION ACTIV LINKS
		$activ['first'] = (bool)($images[0][0] != $id);
		$activ['prev']  = (bool)($images[$this->nav_current - 2][0] != '');
		$activ['next']  = (bool)($images[$this->nav_current][0] != '');
		$activ['last']  = (bool)($images[$this->nav_total - 1][0] != $id);

		//  IMAGE NUMBER
		$this->nav_this = $this->nav_current .' '. $this->lang['of'] .' '. $this->nav_total;

		if ($this->navtype==0) { $this->text_imagenavigation($links, $activ); return; }
		if ($this->navtype==1) { $this->icon_imagenavigation($links, $activ, $admin); return; }
	}

	// IMAGE NAVIGATION BY TEXTSTRING
	function text_imagenavigation($links, $activ) {
		// FIRST IMAGE
		if ($activ['first'])
			$this->nav_first = $links['first'] . $this->lang['first'] .'</a>';
		else
			$this->nav_first = $this->lang['first'];

		// PREV IMAGE
		if ($activ['prev'])
			$this->nav_prev = $links['prev'] . $this->lang['prev'] .'</a>';
		else
			$this->nav_prev = $this->lang['prev'];

		// NEXT IMAGE
		if ($activ['next'])
			$this->nav_next = $links['next'] . $this->lang['next'] .'</a>';
		else
			$this->nav_next = $this->lang['next'];

		// LAST IMAGE
		if ($activ['last'])
			$this->nav_last = $links['last'] . $this->lang['last'] .'</a>';
		else
			$this->nav_last = $this->lang['last'];
	}

	// IMAGE NAVIGATION BY ICONS
	function icon_imagenavigation($links, $activ, $admin) {

		$navigation = array ('first' => array('navstr' => &$this->nav_first),
									'prev'  => array('navstr' => &$this->nav_prev),
									'next'  => array('navstr' => &$this->nav_next),
									'last'  => array('navstr' => &$this->nav_last)
								  );

		// GENERATE NAVIGATION STRINGS
		$iconpath.= 'skins/';
		$iconpath.= ($admin)? 'admin':$this->activeskin;
		$iconpath.= '/images/';
		foreach ($navigation as $key=>$record) {
			if ($activ[$key]) {
				$icon = $iconpath . $key .'_activ.gif';
				$size = (is_readable($icon))? getimagesize($icon):'';
				$record['navstr'] = $links[$key] .'<img src="'. $icon .'" '. $size[3] .' border="0" alt="';
				$record['navstr'].= $this->lang[$key].'" title="'.$this->lang[$key].'" align="absmiddle" /></a>';
			}
			else {
				$icon = $iconpath . $key .'_inactiv.gif';
				$size = (is_readable($icon))? getimagesize($icon):'';
				$record['navstr'] = '<img src="'. $icon .'" '. $size[3] .' border="0" alt="" align="absmiddle" />';
			}
		}
	}

	//
	// GALLERY NAVIGATION
	// kh_mod 0.1.0, changed
	function gallerynavigation($delimiter) {
		if ($_REQUEST['id'] != '') {
			global $select_image;
			$list = $select_image[0][2];
		}
		elseif ($_REQUEST['list'] != '') {
			$list = $this->parentfolder;
		}
		else {
			$list = 'root';
		}

		do {
			$result = $this->select($list,$this->all_folders,0,0,0,6);
			if (empty($result)) { $folderpath = array(); break; }

			$foldername = ($list != '1' || $result[0][2] != '')?
								$result[0][2]
								:
								$this->lang['gallery'];
			$item = '<a href="'. $this->indexfile .'?list='. $list .'">'. $foldername .'</a>';
			$folderpath[$list] = $item;
			$list					 = $result[0][1];
			if (!empty($folderpath[$list])) break;
		}
		while ((int)$list > 0);

		if ($this->websitelink != '')
			$folderpath[] = '<a href="'. $this->websitelink .'">'. $this->websitetext .'</a>';
		echo implode(" $delimiter ", array_reverse($folderpath));
	}

	//
	// PAGE NAVIGATION
	// kh_mod 0.1.0 rc1, changed
	function pagenavigation($pages, $list) {
		if ($pages > 1) {
			$arrnav[] = '<div align="center">'. $this->lang['page'];
			for ($i=1; $i <= $pages; $i++) {
				$arrnav[] = ($GLOBALS['current_page'] == $i)?
								$i
								:
								'<a href="'. $this->indexfile .'?list='.$list.'&amp;page='.$i.'">'. $i .'</a>';
			}
			$arrnav[] = ($GLOBALS['current_page'] == 'all')?
							$this->lang['all']
							:
							'<a href="'. $this->indexfile .'?list='.$list.'&amp;page=all">'. $this->lang['all'] .'</a>';
			echo implode(' | ', $arrnav), '</div><br />';
		}
	}

	//
	// SEARCH IMAGE DATABASE
	// kh_mod 0.1.0, changed
	function search_iDB($string, $field){
		$n_images = count($this->all_images);
		for ($i=0; $i < $n_images; $i++) {
			if ($this->all_images[$i][$field] == $string) {
				return $i;
			}
		}
		return false;
	}

	//
	// SEARCH FOLDER DATABASE
	// kh_mod 0.1.0, changed
	function search_fDB($string, $field){
		$n_folders = count($this->all_folders);
		for ($i=0; $i < $n_folders; $i++) {
			if ($this->all_folders[$i][$field] == $string) {
				return $i;
			}
		}
		return false;
	}

	//
	// DETERMINE THUMBNAIL FOR FOLDER
	// kh_mod 0.1.0, changed
	function getthumb($folder) {

		// IS SET FOLDER THUMB?
		if ($folder[7] != '' && $this->foldericons != '1') {
			$thumbfile = $this->imagefolder .'/'. $folder[7];
			if (is_file($thumbfile)) {
				$this->width  = $folder[8];
				$this->height = $folder[9];
				$this->subfolder_class = 'subfolder border';
				return $thumbfile;
			}
		}

		// IS SET FOLDER PASSWORD?
		if ($folder[5] != '') {
			$thumbfile = "skins/$this->activeskin/images/locked.gif";
			$this->width  = '150';
			$this->height = '100';
			$this->subfolder_class = 'subfolder';
			return $thumbfile;
		}

		// DOES FOLDER CONTAIN IMAGES?
		$subfiles   = $this->select($folder[0],$this->all_images,2,0,0,10);
		$subfolders = $this->select($folder[0],$this->all_folders,1,0,0,6);
		if (count($subfiles) > 0 && $this->foldericons != '1') {
			$random = array_rand($subfiles);
			$thumbfile = $this->thumb($subfiles[$random][1]);
			if (is_file($thumbfile)) {
				$this->width  = $subfiles[$random][8];
				$this->height = $subfiles[$random][9];
				$this->subfolder_class = 'subfolder border';
				return $thumbfile;
			}
		}

		// FOLDER NOT EMPTY?
		if (count($subfolders) > 0 || count($subfiles) > 0) {
			$thumbfile = "skins/$this->activeskin/images/folder.gif";
			$this->width  = '150';
			$this->height = '100';
			$this->subfolder_class = 'subfolder';
			return $thumbfile;
		}

		// FOLDER IS EMPTY
		$thumbfile = "skins/$this->activeskin/images/emptyfolder.gif";
		$this->width  = '150';
		$this->height = '100';
		$this->subfolder_class = 'subfolder';
		return $thumbfile;
	}

	//
	// READ FOLDER SETTINGS
	// kh_mod 0.1.0, changed
	function getfoldersettings($list, $admin=false) {
		if ($admin===true) {
			$folder = $this->select($list,$this->all_folders,0,0,0);
		} else {
			$folder = $this->select($list,$this->all_folders,0,0,0,6);
		}
		if ($folder) {
			if ($list == '1') $this->parentfolder = 'root';
			else $this->parentfolder = $folder[0][1];
			if ($folder[0][3] == '') $this->folder_sortby = 1;
			else $this->folder_sortby = (int)$folder[0][3];			// kh_mod 0.1.0 b3, changed
			if ($folder[0][4] == '') $this->folder_sortway = 0;
			else $this->folder_sortway = (int)$folder[0][4];		// kh_mod 0.1.0 b3, changed
			if (!isset($folder[0][6])) $this->folder_publish = 0;	// kh_mod 0.1.0 b3, changed
			else $this->folder_publish = (int)$folder[0][6];		// kh_mod 0.1.0 b3, changed
			if (!isset($folder[0][10])) $this->introtext = '';
			else $this->introtext = $folder[0][10];
			if (!isset($folder[0][11])) $this->folder_position = '1';
			else $this->folder_position = $folder[0][11];
			return true;
		} else
			return false;
	}

	//
	// JAVASCRIPT VERIFY FOR COMMENTS
	// kh_mod 0.1.0, add
	function jsformvalid() {
		$validpath = 'includes/mg2_jsformvalid.php';
		if ((($this->commentsets&5)===5) && is_readable($validpath)) {
			include($validpath);
		} else {
			echo '<script language="JavaScript" type="text/javascript">
					<!--
						function validateCompleteForm(a,b) { return true; }
					-->
					</script>';
		}
	}

	//
	// GET GD LIB VERSION
	//
	function gd_version() {
		$gdInfo = gd_info();
		$this->gd_version_number = trim(preg_replace("/[a-z()]/i", "", $gdInfo["GD Version"]));	// kh_mod 0.1.0, changed
		return $this->gd_version_number;
	}

	//
	// GET FOLDER NAME
	// kh_mod 0.1.0, changed
	function getfoldername($list) {
		$result = $this->select($list,$this->all_folders,0,0,0);
		if ($result)
			return ($result[0][0] == '1')? $this->lang['root']:$result[0][2];
		else
			return '';
	}

	//
	// GALLERY SECURITY
	// kh_mod 0.1.0, changed
	function gallerysecurity($list,$first='') {
		$first  = ($first)? $first:$list;
		$result = $this->select($list,$this->all_folders,0,0,0);
		$folderpwd = ($result)? $result[0][5]:'';
		if ($folderpwd !== '' && $folderpwd !== $_SESSION['folderpwd'][$list]) {
			if (md5(strrev(md5($_POST['password']))) === $folderpwd) {
				$_SESSION['folderpwd'][$list] = $folderpwd;
				$_POST['password'] = '';
			}
			else {
				$this->introtext  = '';
				$this->startimage = '';
				$img_id = ($_REQUEST['id'] != '')? $_REQUEST['id']:false;
				unset($_REQUEST['id']);
				$_REQUEST['list']	= $list;
				thumbnails_begin(1, $list);
				if ($img_id) {
					unset($_REQUEST['list']);
					$_REQUEST['id']	= $img_id;
				} else {
					$_REQUEST['list']	= $first;
				}	
				include("skins/$this->activeskin/templates/thumbnails_password.php");
				exit();
			}
		}
		// PASSWORD MAGEMENT RECURSIV
		if (($this->extendedset & 1) && $list > 1) {
			$parent = ($result)? $result[0][1]:1;
			$this->gallerysecurity($parent,$first);
		}
		return;
	}

	// kh_mod 0.1.0 b3, changed
	function charfix($string, $trim='') {
		$string = trim($string);
		if ($trim) $string = trim($string,$trim);
		$string = str_replace("*","#",$string);		// item delimiter in database
		$string = str_replace('\"','"',$string);		// to avoid magic quots 
		$string = str_replace("\'","'",$string);		// to avoid magic quots
		return $string;
	}

	// kh_mod 0.1.0, changed
	function readcomments($comment_file) {
		$this->comments = array();
		if (is_readable($comment_file)) {
			$fd = @fopen($comment_file,'r');
			while ($fd && !feof($fd)) {
				if (fgets($fd,2) == '*')
					$this->comments[] = fgetcsv($fd,4096,'*');
			}
			fclose($fd);
			$this->log("Read file comments from '$comment_file'");
		}
		elseif (is_file($comment_file)) {
			$this->log("ERROR: Couldn't read file comments from '$comment_file'!");
			return false;
		}
		$this->sort($this->comments,0,$this->commentsets & 2);
		return count($this->comments);
	}

	// kh_mod 0.1.0, changed
	function writecomments($comment_file) {
		if (is_file($comment_file))
		if (!is_writeable($comment_file))		return false;
		if (!is_writeable($this->imagefolder))	return false;

		$fok = false;
		if (@is_array($this->comments)) {
			$buffer = '';
			$citems = 4;
			foreach ($this->comments as $record) {
				for ($i=0; $i<$citems; $i++) {
					$buffer .= "*". $record[$i];
				}
				$buffer .= "\n";
			}
			$fd = fopen($comment_file,'w');
			if (flock($fd, LOCK_EX)) {	// do an exclusive lock
				$fok = fwrite($fd, $buffer);
				flock($fd, LOCK_UN);		// release the lock
				fclose($fd);
				if ($fok!==false) $this->log("Wrote comment file '$comment_file' ($fok byte)");
			} else {
				$this->log("ERROR: Could not lock commentfile '$comment_file' for writing");
			}
		}
		return $fok;
	}

	// kh_mod 0.1.0, changed
	function addcomment($filename) {
		$add_ok = false;
		do {
			// READ COMMENT FILE
			$commfile  = $this->comment($filename);
			$commentID = $this->readcomments($commfile);
			if ($commentID===false) { $this->status = $this->lang['commenterror']; break; }

			// INPUT AND CLEAN NEW COMMENT
			if (!$this->cleancomment($commentID)) break;

			// WRITE NEW COMMENT
			$this->comments[$commentID][0] = time();
			$add_ok = $this->writecomments($commfile);
			$this->status = ($add_ok)? $this->lang['commentadded']:$this->lang['commenterror'];

			// SEND COMMENT EMAIL
			if (($this->commentsets & 8) && $this->adminemail) {
				$to		= $this->adminemail;
				$subject	= $this->gallerytitle .": ". $this->lang['commentadded'];
				$body		= strtoupper($this->lang['from']) .":\n";
				$body	  .= $this->comments[$commentID][1] ."(". $this->comments[$commentID][2] .")\n\n";
				$body	  .= strtoupper($this->lang['comment']) .":\n";
				$body	  .= str_replace("<br />", "\n",$this->comments[$commentID][3]) ."\n\n";
				$body	  .= "http://". $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"] ."?id=". $_REQUEST['id'];
				$body	  .= (!$add_ok)? "\n\nERROR: Could not write comment file!":"";
				$from		= "From: ". $this->comments[$commentID][2] ."\nReply-to: ". $this->comments[$commentID][2];
				$mail_ok	= @mail($to, $subject, $body, $from);
				$this->log(($mail_ok)? "Send comment by email":"ERROR: Couldn't send new comment by email!");
			}
		} while(0);
		$this->sort($this->comments,0,$this->commentsets & 2);	// kh_mod 0.1.0 b3, moved from line 632
		if (!$add_ok) $this->log('ERROR: Couldn\'t added comment on \''.$commfile.'\'!');
		return $add_ok;
	}

	function cleancomment($commentID) {
		// CLEAN UP INPUT
		$name	 = $_REQUEST['name']  = $this->charfix(substr($_REQUEST['name'],0,90));
		$email = $_REQUEST['email'] = $this->charfix(substr($_REQUEST['email'],0,90));
		$input = $_REQUEST['input'] = $this->charfix(substr($_REQUEST['input'],0,4096));
		$input = @strip_tags($input, '<b></b><i></i><u></u><strong></strong><em></em>');
		$input = @preg_replace('/\r\n|\r|\n/', '<br />', $input);

		// ARE ALL FIELDS NOT EMPTY?
		if ($email == "" || $name == "" || $input == "") {
			$this->status = $this->lang['commentmissing']; return false;
		}

		// EMAIL CORRECT?
		$cClass = '[_a-z'.$this->lang['specialchars'].'0-9-]';
		$regexp = '/^'.$cClass.'+(\.'.$cClass.'+)*@'.$cClass.'+(\.'.$cClass.'+)*\.([a-z]{2,5})$/i';
		if (!@preg_match($regexp, $email)) {
			$this->status = $this->lang['emailerror']; return false;
		}

		// CHECK ALL FIELDS (INPUT, NAME, EMAIL)
		$comment_exists = $this->select($input,$this->comments,3,0,0);
		$comment_exists = $this->select($name,$comment_exists,1,0,0);
		$comment_exists = $this->select($email,$comment_exists,2,0,0);
		if (count($comment_exists) < 0) {
			$this->status = $this->lang['commenterror'];  return false;
		}
		if (count($comment_exists) > 0) {
			$this->status = $this->lang['commentexists']; return false;
		}

		// SAVE ENRIES
		$this->comments[$commentID][1] = htmlspecialchars($name, ENT_QUOTES);
		$this->comments[$commentID][2] = $email;
		$this->comments[$commentID][3] = $input;

		// RETURN ENTRIES
		return true;
	}

	// kh_mod 0.1.0 rc1, add
	function checkLanguage($lang) {
		return (!empty($lang) && is_readable('lang/'. $lang))? true:false;
	}

	// kh_mod 0.1.0, changed
	function output($var) {
		echo (isset($this->$var))? $this->$var:'';
	}

	// kh_mod 0.1.0 b3, changed
	function log($entry, $block=false) {
		$logfile = "mg2_log.txt";
		// DELETE LARGE LOG FILE
		if (is_file($logfile) && filesize($logfile) > 300000) unlink($logfile);
		// CREATE NEW LOGFILE
		if (!$block) $entry = date("Ymd, H.i.s : ") . $entry . "\n";
		if (is_file($logfile)) {
			$fd = fopen($logfile,"a+");
			fwrite($fd, $entry);
		} else {
			$fd = fopen($logfile,"a+");
			fwrite($fd,"MG2 LFS (Log File System)\n\n");
			fwrite($fd,"Version: " . $this->version . "\n");
			fwrite($fd,"Install date: " . date("Y-m-d",$this->installdate) . "\n\n---LOG BEGIN------------------\n\n");
			fwrite($fd, $entry);
		}
	}

	// kh_mod 0.1.0, add
	function image($name) {
		return $this->imagefolder .'/'. $name;
	}

	// kh_mod 0.1.0, changed
	function medium($name) {
		$ext = strrchr($name, '.');
		$len = strlen($ext);
		if ($len > 1) {
			$name = $this->imagefolder .'/'. substr($name, 0, -$len) .'_medium'. $ext;
		}
		return $name;
	}

	// kh_mod 0.1.0, changed
	function thumb($name) {
		$ext = strrchr($name, '.');
		$len = strlen($ext);
		if ($len > 1) {
			$name = $this->imagefolder .'/'. substr($name, 0, -$len) .'_thumb'. $ext;
		}
		return $name;
	}

	// kh_mod 0.1.0, changed
	function comment($name) {
		return $this->imagefolder .'/'. $name .'.comment';
	}

	//
	// CONVERT DATE TO TIMESTAMP
	// kh_mod 0.1.0 b3, add
	function date2time($date='') {
		if (empty($date))	return time();

		// DATE FORMAT
		$dateForm  = $this->dateformat;

		// ALLOW DATE FORMATS
		$regexp1 = '/(%d|%e)(.*)(%b|%m)(.*)(%y|%Y)/';
		$regexp2 = '/(%b|%m)(.*)(%d|%e)(.*)(%y|%Y)/';
		$regexp3 = '/(%y|%Y)(.*)(%b|%m)(.*)(%d|%e)/';

		// CHECK DATE FORMAT AND DETERMINE ORDER
		if (@preg_match($regexp1,$dateForm, $item)) {
			$res = array(2,1,3);  // DAY, MONTH, YEAR
		}
		elseif (@preg_match($regexp2,$dateForm, $item)) {
			$res = array(1,2,3);  // MONTH, DAY, YEAR
		}
		elseif (@preg_match($regexp3,$dateForm, $item)) {
			$res = array(2,3,1);  // YEAR, MONTH, DAY
		}
		else return false;

		// DETERMINE DATE REGEXP
		$regexp = '';
		foreach ($item as $a) {
			switch ($a) {
				case '%d': $regexp.= '(\d{2}|\d{1})';	break;
				case '%e': $regexp.= '(\d{2}|\d{1})';	break;
				case '%b': $regexp.= '(\w{3}\.?)';		break;
				case '%m': $regexp.= '(\d{2}|\d{1})';	break;
				case '%y': $regexp.= '(\d{2})';			break;
				case '%Y': $regexp.= '(\d{4})';			break;
				case ''  : $regexp.= '';					break;
				default:   $regexp.= '\W*';
			}
		}
		$regexp = '/'. $regexp .'\W*(\d{1,2})?\W*(\d{2})?/';

		// GET EACH DATE VALUE
		$timestamp = false;
		if (@preg_match($regexp, $date, $split)) {
			$D = (int)$split[$res[1]];					// DAY
			$Y = (int)$split[$res[2]];					// YEAR
			if (!isset($split[4])) $split[4] = 0;	// HOUR
			if (!isset($split[5])) $split[5] = 0;	// MINUTE

			// MONTH TO NUMBER
			if (strlen($M) > 2) {
				$M = ucfirst(strtolower($split[$res[0]]));
				$M = 1 + array_search(substr($M,0,3),$this->lang['months']);
			} else {
				$M = (int)$split[$res[0]];
			}

			// CHECK DATE
			if (checkdate($M, $D, $Y)) {
				$mk = @mktime((int)$split[4], (int)$split[5], 0, $M, $D, $Y);
				if ($mk > 0) $timestamp = $mk;
			}
		}
		return $timestamp;
	}

	//
	// CONVERT TIMESTAMP TO DATE
	// kh_mod 0.1.0 b3, add
	function time2date($timestamp='', $showTime=false) {
		if (empty($timestamp)) $timestamp = time();
		$dateForm = $this->dateformat;
		if ($showTime===true) $dateForm .= ', %H:%M';

		// SIMULATION '%e'
		$replace  = sprintf("%'2d", date("j", $timestamp));
		$dateForm = str_replace('%e',$replace,$dateForm);

		// SIMULATION '%b' (lokalisiert)
		$replace  = $this->lang['months'][(date("m", $timestamp)-1)];
		$dateForm = str_replace('%b',$replace,$dateForm);

		// Datum und Uhrzeit formatiert
		return strftime($dateForm, $timestamp);
	}
}	// END CLASS' mg2db'

//
// CLICK COUNTER CLASS
// kh_mod 0.1.0 rc1, add
class MG2counter {
	var $database = 'database.txt';

	// INITIALIZE COUNTER
	function MG2counter($array=array()) {
		if (!is_array($array)) return;
		$this->data = $array;
		$this->loadDatabase();
	}

	function loadDatabase() {
		if ($fp = @fopen($this->database, 'r')) {
			while (!feof($fp)) {
				$line = fgets($fp);
				if ($line != '') {
					$item = split('\|', $line);
					$this->data[trim($item[0])] = trim($item[1]);
				}
			}
		}
	}

	function plusDatabase($id) {
		$this->data[$id]++;
		if ($fp = @fopen($this->database, 'w')) {
			foreach($this->data as $key=>$item) {
				fwrite($fp, $key ."|". $item ."\n");
			}
			fclose($fp);
		}
	}
}	// END CLASS' MG2Counter'
?>