<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    If you find this script useful, please make a donation via the main       //
//    website:                                                                  //
//                          http://www.minigal.dk                               //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

// DISPLAY ERRORS BUT HIDE NOTICES
@error_reporting(E_ALL ^ E_NOTICE);

//SET PHP ARGUMENT SEPERATOR ON '&AMP'
@ini_set('arg_separator.output','&amp;');

session_start();

//
// Ordner ausloggen
// kh_mod 0.1.0, add
$logoutmsg = '';
if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'logout') {
	unset($_SESSION['folderpwd']);
	$logoutmsg = '1';
}

// TRIGGER INSTALLATION
if (!is_file('mg2_settings.php')) @include('mg2_install.php');

// MAKE NEW DATABASE OBJECT
@include('includes/mg2_functions.php');
$mg2 = new mg2db;
$mg2->readDB();

// BASIC SETTINGS
$mg2->adminfolder	= 'skins/admin/';
$mg2->extendedset = '29';
$mg2->commentsets =  '6';
$mg2->showexif    =  '0';

// READ FILE SETTINGS
@include('includes/mg2_version.php');
@include('mg2_settings.php');

//
// CHECK LANGUAGE
// kh_mod 0.1.0 rc1, changed
$selectlang = $_SESSION['selectlang'];
if (isset($_GET['ln']) && strlen($_GET['ln']) == 2) {
	switch ($_GET['ln']) {
		// ISO 639-1
		case 'en': $selectlang = 'english.php'; break;
		case 'de': $selectlang = 'german.php';  break;
		case 'sv': $selectlang = 'swedish.php'; break;
		case 'el': $selectlang = 'greek.php'; 	 break;
		case 'sr': $selectlang = 'srpski.zip';	 break;
	}
}
do {
	if ($mg2->checkLanguage($selectlang))	break;
	$selectlang = $_SESSION['selectlang'];
	if ($mg2->checkLanguage($selectlang))	break;
	$selectlang = $mg2->defaultlang;
	if ($mg2->checkLanguage($selectlang))	break;
	$selectlang = 'english.php';
	if ($mg2->checkLanguage($selectlang))	break;
	$mg2->status = 'The language "'. ucfirst(substr($mg2->defaultlang,0,-4));
	$mg2->status.= '" is not available!';
}
while(0);

// SET AND LOAD LANGUAGE
$_SESSION['selectlang'] = $selectlang;	@include('lang/'. $selectlang);

// SET HEADERS TO PREVENT BROWSER CACHING OF PAGES
@header('Content-Type: text/html; charset='.$mg2->charset);
@header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');

//
// SKIN SETTINGS
//  kh_mod 0.1.0 b3, changed
$skinpath = 'skins/'. $mg2->activeskin .'/';
if (!is_readable($skinpath .'templates')) {
	$message = 'The skin "'. ucfirst($mg2->activeskin) .'" is not available!';
	include($mg2->adminfolder .'fatal_error.php');
	exit();
}
if (is_readable($skinpath .'settings.php')) {
	include($skinpath .'settings.php');
}

//
// FOLDER AND IMAGE SETTINGS
// kh_mod 0.1.0, add
$id				= false;
$select_image	= false;
$list				= "1";
if ($_REQUEST['slideshow'] != '') {
	$id = @strip_tags($_REQUEST['slideshow']);
	$select_image = $mg2->select($id, $mg2->all_images,0,0,0,10);
	if (!empty($select_image))
		$list = $select_image[0][2];
	else
		unset($_REQUEST['slideshow']);
}

if ($_REQUEST['id'] != '' && empty($select_image)) {
	$id = @strip_tags($_REQUEST['id']);
	$select_image = $mg2->select($id, $mg2->all_images,0,0,0,10);
	if (!empty($select_image))
		$list = $select_image[0][2];
	else
		unset($_REQUEST['id']);
}

//
// PAGE OF THUMBNAILS
// kh_mod 0.1.0, add
if ($_REQUEST['page'] != '')
	$current_page = @substr($_REQUEST['page'],0,4);
else
	$current_page = '1';

//
// NOT EXISTS IMAGE IN DATABASE?
// kh_mod 0.1.0, add
if ($id && empty($select_image)) notexists($id);

//
// FOLDER SETTINGS
// kh_mod 0.1.0, add
if ($_REQUEST['list'] != '' && !$id) {
	$list = @strip_tags($_REQUEST['list']);
}
$is_folder = $mg2->getfoldersettings($list);

//
// NOT EXISTS FOLDER OR PUBLISH NOT YET?
// kh_mod 0.1.0, add
if (!$is_folder) notexists($id);

//
// FOLDER PUBLISH NOT YET - TEST RECURSIV
// kh_mod 0.1.0, add
$parent = $mg2->parentfolder;
while ((int)$parent > 0) {
	$fid[$parent] = '1';
	$folder = $mg2->select($parent,$mg2->all_folders,0,0,0,6);
	if (count($folder) < 1)		notexists($id);			// kh_mod 0.1.0 b3, add
	$parent = $folder[0][1];									// kh_mod 0.1.0 b3, add
	if ($fid[$parent] == '1')	notexists('demaged');	// kh_mod 0.1.0 b3, changed
}

//
// PASSWORD SECURITY
//
$mg2->gallerysecurity($list);


///////////////////////////
//	DISPLAY IMAGES	//
//////////////////////////
if ($_REQUEST['slideshow']) {
	// SLIDESHOW
	include ('includes/mg2_slideshow.php');
}
elseif ($_REQUEST['id']) {
	// DISPLAY IMAGE
	include ('includes/mg2_showimages.php');
}
else {
	// INDEX (THUMBS)
	include ('includes/mg2_showthumbs.php');
}
?>
